#ifndef _SXX_RESPONSE_PARSER_
#define _SXX_RESPONSE_PARSER_

#include "client_socket.h"
#include "response.h"
#include <exception>
using namespace sxx_socket;
using namespace sxx_response;
using std::exception;

namespace sxx_generator {

class response_generator {
private:
	client_socket output;

	static const char* status_description(int status);
	static string normalize(const string& str);
	static string hex_encode_char(unsigned char x);
	static string hex_encode(const string& str);

	void initial(const response& response);
	void added_headers(const response& response);
	void cookie_headers(const response& response);
	void misc_headers(const response& response);
	void content_headers(const response& response);
	void content(const response& response);

public:
	response_generator(const client_socket& output);
	void put_response(const response& response);

};

class response_generator_failure: public exception {
public:
	virtual const char* what() const throw();
};

class response_generator_close_exception: public exception {
public:
	virtual const char* what() const throw();
};

} // end of namespace sxx_generator.

#endif

