#ifndef _SXX_SESSION_
#define _SXX_SESSION_

#include "var.h"
#include <pthread.h>
#include <exception>
#include <time.h>
#include <vector>
#include <string>
#include <map>

namespace sxx_session {

class session_exception: public exception {
public:
	virtual const char* what() const throw();
};

class session_manager {
private:
	typedef std::string str;
	typedef sxx_var::var var;
	typedef std::pair<time_t, var> ptv;
	typedef std::map<str, ptv> s2tv;
	typedef session_exception s_ex;

	static pthread_mutex_t lock;
	static pthread_t recycle_thread;
	static s2tv table;

	session_manager();
	static session_manager* me;

public:
	static void* session_recycle(void* args);
	static session_manager& instance();
	static void destroy();
	static var& session_var(str id);
	static str new_session();
	static void close_session(str id);
};

}

#endif

